#!/bin/sh
PrintCGIHeader () {
echo "Content-type: text/html"
    echo
}
PrintRealLogin () {
	echo "in PrintRealLogin from $1" > /ram/out.txt
    cat wakeup/index.html
}
PrintInvalidLogin () {
	echo "in PrintInvalidLogin from $1" > /ram/out.txt
    cat wakeup/wakeup_failed.html
}
#move the above down below to turn off book marking
if [ "${QUERY_STRING}" != "" ]
then
    PrintCGIHeader
    ext=`getvalue ext "${QUERY_STRING}"`
    page=`getvalue navPage "${QUERY_STRING}"`
    firstLogin=`getvalue firstLogin "${QUERY_STRING}"`
    adminExt=`getvalue adminExt "${QUERY_STRING}"`
    if [ "${adminExt}" = "" ] && [ "${firstLogin}" != "yes" ]
    then
        PrintInvalidLogin 24
        exit
    elif [ "${adminExt}" != "" ] && [ "${firstLogin}" != "yes" ]
    then
    	ext=${adminExt}
    elif [ "${adminExt}" = "" ] && [ "${firstLogin}" = "yes" ] && [ "${HTTP_REFERER}" != "" ]
    then
    	adminExt=${ext}
    else
        PrintInvalidLogin 31
        exit
    fi
    if [ "${page}" = "wakeup_calls_login.html" ] && [ "${firstLogin}" = "yes" ]
    then
        #logout was clicked
        if [ "${adminExt}" != "" ]
        then
            rm -f /ram/wakeup_${adminExt}.*
        else
            rm -f /ram/wakeup_${ext}.*
        fi
        PrintRealLogin 39
        exit
    fi
    pinExt=${adminExt}

    #first time log in
    #else if a regular page get the saved pin
    #else we are logging in with a pin make sure to use the new one
    if [ "${page}" = "wakeup_calls.html" ] && [ "${firstLogin}" = "yes" ]
    then
        webPin=`getvalue pin "${QUERY_STRING}"`
        if [ "${webPin}" != "" ]
        then
            webPin=`echo "${webPin}" |sed 's/%23/#/g'`
        fi
        pin=${webPin}
        echo "${pin}" > /ram/wakeup_${pinExt}.pin
    else 
        pin=`cat /ram/wakeup_${pinExt}.pin`
    fi

    Login=`/sbin/officeadmin "${pinExt}" "${pin}" 5 2102 login ${ext}`
        
    sysPin=`printcol "${Login}" "=" 1`
    accessLevel=`printcol "${Login}" "=" 2`
    if [ ${accessLevel} -ge 4 ] && [ "${adminExt}" = "" ]
    then
        adminExt=${ext}
    elif [ ${accessLevel} -lt 4 ]
    then
            PrintInvalidLogin 84
            exit
    fi

    #these are in selected pages repopulate with user data or from system
    if [ "${pin}" = "${sysPin}" ]
    then
        #page specifics down below
        if [ "${page}" = "wakeup_calls.html" ]
        then
		wakeupDay=`getvalue wakeupDay "${QUERY_STRING}"`
		daySubmitted=`getvalue daySubmitted__ "${QUERY_STRING}"`
		hourSubmitted=`getvalue hourSubmitted__ "${QUERY_STRING}"`
		minSubmitted=`getvalue minSubmitted__ "${QUERY_STRING}"`
		if [ "${wakeupDay}" != "" ] && [ "${wakeupDay}" != "-Select-" ]
		then
			#this is a set
			wakeupHour=`getvalue wakeupHour "${QUERY_STRING}"`
			wakeupMinute=`getvalue wakeupMinute "${QUERY_STRING}"`
			
			if [ ${wakeupHour} -lt 10 ]
			then
				wakeupHour="0${wakeupHour}"
			fi

			userCancel=`getvalue userCancel "${QUERY_STRING}"`
			ext=`getvalue ext "${QUERY_STRING}"`
			day=`date +%_d`
			month=`date +%m`
			year=`date +%Y`
			selectedExt=`getvalue selectedExt "${QUERY_STRING}"`
			if [ "${selectedExt}" = "" ]
			then
			    selectedExt=${ext}
			fi

#			midEpoch=`date -d "${daymonth}0000${year}" +%s`
#			if [ "${wakeupDay}" = "1" ]
#			then
#				time=$(($midEpoch+${wakeupHour}*60*60+${wakeupMinute}*60))
#			elif [ "${wakeupDay}" = "2" ]
#			then
#				midEpoch=$(($midEpoch+24*60*60))
#				time=$(($midEpoch+${wakeupHour}*60*60+${wakeupMinute}*60))
#			fi

			if [ "${wakeupDay}" = "2" ]
			then
				day=$(($day+1))
            else
                day=$(($day+0))
			fi
			if [ ${day} -lt 10 ]
			then
				day="0${day}"
			fi
			
			time=`date -d "${month}${day}${wakeupHour}${wakeupMinute}${year}" +%s`
#			echo "Wakeup for ${selectedExt}: ${month}${day}${wakeupHour}${wakeupMinute}${year}" > /dev/console

			if [ "${userCancel}" = "1" ]
			then
				#user is doing a cancel
				count=`echo "$5|${selectedExt}"|wc -c`
				count=$((${count} -1))
				/sbin/officeadmin ${ext} ${pin} 5 2102 set "9=2148=${count}=5|${selectedExt}" 0 ${adminExt} > /dev/null
			else
				#user is setting a wakeup time
				count=`echo "${time}|${selectedExt}" |wc -c`
				count=$((${count} - 1))
				/sbin/officeadmin ${ext} ${pin} 5 2102 set "8=2148=${count}=${time}|${selectedExt}" 0 ${adminExt} > /dev/null
			fi
			myUrl=`printcol "${HTTP_REFERER}" "?" 1`
			if [ "${wakeupDay}" != "" ]
			then
				#had submitted day already but we are going to use the new one
				myRefresh="${myUrl}?navPage=${page}&adminExt=${adminExt}&daySubmitted__=${wakeupDay}&hourSubmitted__=${wakeupHour}&minSubmitted__=${wakeupMinute}"
			else
				#cancel was hit and no existing values
				myRefresh="${myUrl}?navPage=${page}&adminExt=${adminExt}"
			fi
			/var/www/vmail_sub.elf /var/www/wakeup_calls_refresh.html $$ ${ext} "${pin}" "${adminExt}" 0 "wakeupUrl|plain|${myRefresh}|"
			exit
		fi
		if [ "${daySubmitted}" != "" ]
		then
        		/sbin/officeadmin ${adminExt} ${pin} 5 2102 get "8=2148=0=" 0 ${adminExt} "${daySubmitted}" "${hourSubmitted}" "${minSubmitted}"
        	else
        		/sbin/officeadmin ${adminExt} ${pin} 5 2102 get "8=2148=0=" 0
        	fi
        fi
    else
        #invalid login print out error CGI header already done
        PrintInvalidLogin 128
    fi
else
    #doing an update with alpha release
    PrintCGIHeader
    cat /var/www/wakeup/index.html                 
        exit 
    echo "about to do an update"
    if [ -e /var/www/html_get.sh ]
    then
    echo "<html>"
    echo "<head>"
    echo "<title>NEC dsx</title>"
    echo "</head>"
    echo "<body>"
        echo "<br><a href=\"wakeup/index.html\">login</a>"
        killall html_get.sh
        killall ftp
        if [ -e /var/www/html_get.sh ]
        then
            /var/www/html_get.sh
            echo "<br>Your system has been updated"
        else
            PrintRealLogin 154
            exit
        fi
    else
        PrintRealLogin 158
        exit
    fi
    echo "<br><a href=\"wakeup/index.html\">login</a>"
    echo "</body>"
    echo "</html>"
    exit
fi
